"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resultConfig = void 0;
const path = __importStar(require("path"));
const webpack_1 = __importDefault(require("webpack"));
const copy_webpack_plugin_1 = __importDefault(require("copy-webpack-plugin"));
const del_1 = __importDefault(require("del"));
const fs_1 = require("fs");
const webpack_merge_1 = require("webpack-merge");
const DynamicLibraryPlugin_1 = require("../plugins/DynamicLibraryPlugin");
const helpers_1 = require("../common/helpers");
const baseConfig_1 = require("./baseConfig");
const settings_1 = require("../settings");
const consts_1 = require("../common/consts");
const SpeedMeasurePlugin = require('speed-measure-webpack-v5-plugin');
const smp = new SpeedMeasurePlugin();
const rootFolder = path.resolve(process.cwd());
const createConfig = function () {
    return __awaiter(this, void 0, void 0, function* () {
        (0, helpers_1.checkVersions)();
        const baseConfig = yield (0, baseConfig_1.createBaseConfig)();
        del_1.default.sync(['dist/*.js', 'dist/*.map'], { cwd: rootFolder });
        const originalWebpackConfig = (0, helpers_1.getJSONFile)('temp/_webpack_config.json');
        baseConfig.externals = originalWebpackConfig.externals;
        baseConfig.output = originalWebpackConfig.output;
        baseConfig.entry = (0, helpers_1.getEntryPoints)(originalWebpackConfig.entry);
        baseConfig.output.publicPath = `https://${baseConfig.devServer.host}:${baseConfig.devServer.port}/dist/`;
        const manifest = (0, helpers_1.getJSONFile)('temp/manifests.json');
        const { localizedResources, externals } = (0, helpers_1.getJSONFile)('config/config.json');
        const modulesMap = {};
        const originalEntries = Object.keys(originalWebpackConfig.entry);
        for (const jsModule of manifest) {
            if (jsModule.loaderConfig
                && jsModule.loaderConfig.entryModuleId
                && originalEntries.indexOf(jsModule.loaderConfig.entryModuleId) !== -1) {
                const entryModuleId = jsModule.loaderConfig.entryModuleId;
                modulesMap[entryModuleId + '.js'] = {
                    id: jsModule.id,
                    version: jsModule.version,
                    path: jsModule.loaderConfig.scriptResources[entryModuleId].path,
                    isBundle: originalWebpackConfig.entry[jsModule.loaderConfig.entryModuleId].indexOf('bundle-entries') !== -1
                };
            }
        }
        baseConfig.output.filename = function (pathInfo) {
            const entryPointName = pathInfo.chunk.name + '.js';
            if (!modulesMap[entryPointName]) {
                return '[name].js';
            }
            return modulesMap[entryPointName].path;
        };
        baseConfig.plugins.push(new DynamicLibraryPlugin_1.DynamicLibraryPlugin({
            modulesMap: modulesMap,
            libraryName: originalWebpackConfig.output.library
        }));
        const patterns = (0, helpers_1.addCopyLocalizedResources)(localizedResources);
        if (patterns && patterns.length > 0) {
            baseConfig.plugins.push(new copy_webpack_plugin_1.default({
                patterns
            }));
        }
        (0, settings_1.applyServeSettings)(baseConfig);
        const localExternals = (0, helpers_1.createLocalExternals)(externals);
        const localExternalsPatterns = (0, helpers_1.addCopyLocalExternals)(localExternals, manifest, originalEntries);
        if (localExternalsPatterns && localExternalsPatterns.length > 0) {
            baseConfig.plugins.push(new copy_webpack_plugin_1.default({
                patterns: localExternalsPatterns
            }));
        }
        return baseConfig;
    });
};
const resultConfig = () => __awaiter(void 0, void 0, void 0, function* () {
    const originalConfig = yield createConfig();
    const extendPath = path.join(rootFolder, `${consts_1.fastFolderName}/webpack.extend`);
    if ((0, fs_1.existsSync)(`${extendPath}.js`)) {
        const { transformConfig, webpackConfig } = require(extendPath);
        return smp.wrap((0, webpack_merge_1.merge)(transformConfig(originalConfig, webpack_1.default), webpackConfig));
    }
    return originalConfig;
});
exports.resultConfig = resultConfig;
//# sourceMappingURL=configureWebPack.js.map